Package org.kie.api.conf

## Interface KieBaseOptionsConfiguration

- All Known Subinterfaces:
    `KieBaseConfiguration`

      public interface KieBaseOptionsConfiguration

  A base interface for type safe configurations

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `<T extends SingleValueKieBaseOption> T` | `getOption​(Class<T> option)` | Gets an option value
    `<T extends MultiValueKieBaseOption> T` | `getOption​(Class<T> option, String key)` | Gets an option value for the given option + key.
    `<T extends KieBaseOption> void` | `setOption​(T option)` | Sets an option

- - ### Method Detail

    - #### setOption

          <T extends KieBaseOption> void setOption​(T option)

      Sets an option
      Type Parameters:
        `T` - T
      Parameters:
        `option` - the option to be set. As options are type safe, the option itself contains the option key, and so a single parameter is enough.

    - #### getOption

          <T extends SingleValueKieBaseOption> T getOption​(Class<T> option)

      Gets an option value
      Type Parameters:
        `T` - T
      Parameters:
        `option` - the option class for the option being requested
      Returns:
        the Option value for the given option. Returns null if option is not configured.

    - #### getOption

          <T extends MultiValueKieBaseOption> T getOption​(Class<T> option,
                                                          String key)

      Gets an option value for the given option + key. This method should be used for multi-value options, like accumulate functions configuration where one option has multiple values, distinguished by a sub-key.
      Type Parameters:
        `T` - T
      Parameters:
        `option` - the option class for the option being requested
        `key` - the key for the option being requested
      Returns:
        the Option value for the given option + key. Returns null if option is not configured.